/**
 * Hits1.java
 * jama:http://math.nist.gov/javanumerics/jama/
 **/

import java.io.*;
import java.util.*;

public class Hits1 {
    public static void main(String[] args) throws Exception{
	int d = 50; // Py[W̋tNĂy[Wmax

	try{
	    Maps MAP = new Maps();

	    if(args.length!=0){
		MAP.query = Tools.Input(args[0]);
	    }else{
		System.out.print("query:");
		MAP.query = Tools.Input();
	    }


	    //@RootSet̎擾
	    System.out.println("\n*Make RootSet*");
	    MAP.BaseSet = Googly.todo(MAP.query);
	    MAP.RootSetSize = MAP.BaseSet.size();

	    // BaseSet̎擾
	    System.out.print("\n*Make BaseSet*");
	    MAP = GetURLs.todo(MAP);

	    /* // BaseSet_first.txt
	    PrintWriter P_MAP =
	        new PrintWriter(new BufferedWriter(new FileWriter("BaseSet_first.txt")));
	    P_MAP = Tools.Output(P_MAP,MAP,MAP.LHMap);
	    P_MAP.close();
	    */
	    MAP.BaseSetSize0 = MAP.BaseSet.size();
	    System.out.println("\nBaseSetSize0:"+MAP.BaseSetSize0);

	    // RootSetփNĂy[W̎擾
	    System.out.print("\n\n*Make BaseSet(link:RootSet)*");
	    MAP = Googly.todo2(MAP,d);
	    System.out.println("\nBaseSetSize1:"+MAP.BaseSet.size());
	    /* // DiffOya_linkBS.txt , BaseSet.txt
	    PrintWriter P_DiffOya =
		new PrintWriter(new BufferedWriter(new FileWriter("DiffOya_linkBS.txt")));
	    PrintWriter P_BaseSet =
	        new PrintWriter(new BufferedWriter(new FileWriter("BaseSet.txt")));
	    P_DiffOya = Tools.Output_DO(P_DiffOya,MAP.DiffOya);
	    P_BaseSet = Tools.Output(P_BaseSet,MAP.BaseSet);
	    P_DiffOya.close();
	    P_BaseSet.close();
	    */

	    // 񎟌z̍쐬
	    int size = MAP.BaseSet.size();
	    double[][] Link = new double[size][size];
	    Link = MakeArray.todo(MAP,size);

	    // authority̌vZ
	    double[] Authority = new double[size];
	    Authority = CalculateAuthority_Hub.todo(Link,size);

	    // hub̌vZ
	    double[] Hub = new double[size];
	    Hub = CalculateAuthority_Hub.todo2(Link,size,Authority);
	    //Hub = CalculateAuthority_Hub.todo(Link,size);

	    // sort
	    SortMaps AuthMAP = new SortMaps();
	    SortMaps HubMAP = new SortMaps();
	    AuthMAP = Sort.todo(MAP,Authority,size);
	    HubMAP = Sort.todo(MAP,Hub,size);

	    PrintWriter P_AuthMAP =	    
		new PrintWriter(new BufferedWriter(new FileWriter("_1AuthorityWeight.txt")));
	    PrintWriter P_HubMAP =
	        new PrintWriter(new BufferedWriter(new FileWriter("_1HubWeight.txt")));

	    P_AuthMAP = Tools.Output(P_AuthMAP,AuthMAP,size);
	    P_HubMAP = Tools.Output(P_HubMAP,HubMAP,size);
	    P_AuthMAP.close();
	    P_HubMAP.close();
	    System.out.println("\nBaseSetSize0:"+MAP.BaseSetSize0);
	    System.out.println("BaseSetSize:"+MAP.BaseSet.size());
	    System.out.println("<<<END<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<");
	}catch(Exception e){
	    System.out.println("Hits1 error:"+e);
	}

    }
}
